<?php
/*
Plugin Name: Dismiss Gravity Notices
Plugin URI: wpgear.xyz/dismiss-gravity-notices/
Description: Real Dismiss any Exasperate Notices about GravityForms, GravityView invalid license and e.t.c.
Version: 1.0
Author: WPGear
Author URI: http://wpgear.xyz
License: GPLv2
*/

	$DGN_plugin_url = plugin_dir_url( __FILE__); // со слэшем на конце
    $DGN_Notices = array();

	/* Admin Console - Styles.
	----------------------------------------------------------------- */	
	function DGN_admin_style ($hook) {
		$screen = get_current_screen();
		$screen_base = $screen->base;
	
		if ($screen_base == 'dashboard') {
			global $DGN_plugin_url;
			
			wp_enqueue_style ('dgn_admin_style', $DGN_plugin_url .'admin-style.css');
		}
	}
	add_action ('admin_enqueue_scripts', 'DGN_admin_style' );

	/* Create Dismiss Gravity Notices DashboardWidget
	----------------------------------------------------------------- */		
	function DGN_Create_Dashboard_Widget() {
        if (current_user_can('edit_dashboard')) {
			global $wp_meta_boxes;
			
			wp_add_dashboard_widget('dgn_widget', 'Dismissed Gravity Notices', 'DGN_Dashboard_Widget');			
		}
	}
	add_action('wp_dashboard_setup', 'DGN_Create_Dashboard_Widget');

	/* Dismiss Gravity Notices DashboardWidget
	----------------------------------------------------------------- */	
	function DGN_Dashboard_Widget() {
		global $DGN_Notices;

        $DGN_Notices_Content = '';
        $Notices_Title = ''; 
        $Notices_Msg = '';

        ob_start();

        if ($DGN_Notices) {
            $i = 1;		    

            ?>
            <div class="dgn_notices_box">
                <ul>
                    <?php 					
                    foreach ($DGN_Notices as $notice) {
                        $Notices_Title  = $notice['title'];
                        $Notices_Msg    = $notice['message'];

                        $Element_Notices_ID = "dgn_notice_msg_$i";
                        ?>
                        <li>
                            <div class="dgn_notice_title" title="Click for details" onclick="DGN_Show_Notice(<?php echo $i; ?>)">
                                <?php echo "$Notices_Title";?>
                            </div>

                            <div id="<?php echo $Element_Notices_ID; ?>" class="dgn_notice_msg" style="display: none;">
                                <?php echo $Notices_Msg; ?>
                            </div>
                        </li>
                        <?php                
                        $i = $i+1;
                    }

                    ?>
                </ul>

                <div id="dgn_btn_close" class="dgn_btn_close" style="display: none;">
                    <span title="Click for Hide all opened Notices" onclick="DGN_Hide_Notice()">Hide</span>
                </div>

                <script>
                    function DGN_Show_Notice (Notice_ID) {
                        document.getElementById ('dgn_notice_msg_' + Notice_ID).style.display = 'block';
                        document.getElementById ('dgn_btn_close').style.display = 'block';
                    }

                    function DGN_Hide_Notice () {
                        DGN_Elements = document.querySelectorAll("[id^='dgn_notice_msg_']");

                        var i;
                        for (i = 0; i < DGN_Elements.length; i++) {
                            DGN_Elements[i].style.display = 'none';
                        }

                        document.getElementById ('dgn_btn_close').style.display = 'none';
                    }
                </script>
            </div>
            <?php              
        } else {
            ?>
            <div>nothing</div>
            <?php 
        }
        
        $DGN_Notices_Content = ob_get_clean();

        echo $DGN_Notices_Content;
	}		

	/* Do Real Dismissed.
	----------------------------------------------------------------- */	
	function DGN_procesing ($notices) {
        global $DGN_Notices;

        if ($notices) {
            $i = 0;

            foreach ($notices as $notice) {
				$Notices_Cap    	= $notice['cap'];
				$Notices_Dismiss 	= $notice['dismiss'];
				$Notices_Msg    	= $notice['message'];
				
				$Notices_Title  	= isset($notice['title']) ? $notice['title'] : $Notices_Cap .': ' .$Notices_Dismiss;

                $DGN_Notices[$i]['title']     = $Notices_Title;
                $DGN_Notices[$i]['message']   = $Notices_Msg;

                $i = $i+1;
            }

            $notices = array();
        }

		return $notices;
	}
	add_filter ('gravityview/admin/notices', 'DGN_procesing', 999);